import { Spinner } from "@paperclover/console/Spinner";

const first = new Spinner({
    text: 'Spinner 1: ',
    color: 'blueBright',
});

const second = new Spinner({
    text: () => `Spinner 2: ${random()}`,
    color: 'blueBright',
});
second.fps = 30;

const third = new Spinner<{ value: string }>({
    text: ({ value }) => `Spinner 3: ${value}`,
    color: 'blueBright',
});
third.fps = 4;

for (let i = 0; i < 40; i++) {
    await new Promise(resolve => setTimeout(resolve, 100));
    first.text = `Spinner 1: ${random()}`;
    if (i === 20) {
        second.success('second done!');
    }
    third.update({ value: random() });
}

first.success('first done!');
// third.success('third done!');

function random() {
    return Math.random().toString(36).substring(2, 15);
}