import { beforeEach, expect, test } from "bun:test";
import { getBuffer, reset } from "./test/widget-mock.ts";
import chalk from "chalk";

beforeEach(reset);
test("built-in log levels", () => {
    const console = require("@paperclover/console");
    console.info("log");
    expect(getBuffer()).toEqual(`${chalk.blueBright.bold("info")} log\n`);
    reset();
    console.warn("log");
    expect(getBuffer()).toEqual(`${chalk.yellowBright.bold("warn")} ${chalk.yellowBright("log")}\n`);
    reset();
    console.error("log");
    // Don't check the exact color formatting as it may vary
    expect(getBuffer()).toContain("✖");
    expect(getBuffer()).toContain("log");
});
