// This file is used to test injection in a subprocess
// It should be executed using child_process.spawn

// First argument tells what to test
const testType = process.argv[2];

if (testType === 'basic-injection') {
  // Import and test basic injection
  import('@paperclover/console/inject').then(() => {
    // Check that console methods are replaced
    console.log('INJECTED_LOG');
    console.info('INJECTED_INFO');
    console.warn('INJECTED_WARN');
    console.error('INJECTED_ERROR');
    console.debug('INJECTED_DEBUG');
    
    // Assert
    console.assert(true, 'This should not appear');
    console.assert(false, 'INJECTED_ASSERT');
    
    // Exit when done
    setTimeout(() => process.exit(0), 100);
  });
} else if (testType === 'time-functions') {
  // Import and test timing functions
  import('@paperclover/console/inject').then(() => {
    console.time('TIMER_LABEL');
    console.timeLog('TIMER_LABEL');
    console.timeEnd('TIMER_LABEL');
    
    // Test invalid timer
    console.timeEnd('NONEXISTENT_TIMER');
    
    // Exit when done
    setTimeout(() => process.exit(0), 100);
  });
} else if (testType === 'count-functions') {
  // Import and test count functions
  import('@paperclover/console/inject').then(() => {
    console.count('COUNTER_LABEL');
    console.count('COUNTER_LABEL');
    console.countReset('COUNTER_LABEL');
    console.count('COUNTER_LABEL');
    
    // Exit when done
    setTimeout(() => process.exit(0), 100);
  });
} else if (testType === 'disabled-injection') {
  // NO_COLOR should be passed via spawn options
  import('@paperclover/console/inject').then(() => {
    console.log('DISABLED_COLOR_LOG');
    
    // Exit when done
    setTimeout(() => process.exit(0), 100);
  });
}